/*
 * sndctl  -  a plugin for the Video Disk Recorder
 *        file: soundset.h
 * description: header file for soundset.c
 *
 *      author: Thomas Hildebrandt <toxym@web.de>
 *
 * inspired by and reengineered from 'avolctl'
 * thanks to Martin Prochnow <nordlichtl@martins-kabuff.de>
 */

#ifndef SNDCTL_SOUNDSET_H
#define SNDCTL_SOUNDSET_H

#include "sndctl.h"

/*
 * cSoundSet
 * sound set representation class definition
 */
class cSoundSet {
  private:
    struct control{
      char name[SNDCTL_MAX_LEN_CONTROL_NAME];
      char value[SNDCTL_MAX_LEN_CONTROL_VAL];
    }                  *controls;
    string              id;
    cMixer             *mixer;
    string              name;
    int                 nrOfControls;
    int                 volume;

  public:
    cSoundSet( cMixer*, string );
    ~cSoundSet();

    string         Get( string );
    vector<string> GetControls( void );
    string         GetID( void );
    string         GetName( void );
    bool           Set( string, string );
    bool           Store( string, cPluginSndctl* );
    void           Volume( int = -1 );
};

#endif //SNDCTL_SOUNDSET_H
